\documentclass[]{article}
\usepackage{bm}
\usepackage{graphicx}
\usepackage{float}
\usepackage{subcaption}
%
%opening
\title{IPPR Assignment 3}
\author{Marcus Ackerl, 01330813\\Gabriel Weissenbaeck, 01610048}
%
\begin{document}
%
\maketitle%

The task of this assignment was to implement the \textit{coherence enhancing diffusion}, which is a variant of the Perona-Malik nonlinear diffusion. This diffusion is often used to create an artistic effect on images as it guides the diffusion along regions of similar gradient. First, we should try the implementation on a provided input image with given parameter values for $\alpha$ and $\gamma$. Afterwards we should try on our own images and try different parameter values.  
\section*{Results}
Figures \ref{fig:input} and \ref{fig:output} show the given input image and the resulting output image after applying the \textit{coherence enhancing diffusion}.\\
\\
Figure \ref{fig:input_handy} shows the image that was used for testing different values for $\alpha$ and $\gamma$.\\
Figures \ref{fig:output_gamma_0.0001} to \ref{fig:output_gamma_0.1} show the resulting outputs for varying the gamma parameter $\gamma \in \{0.0001, 0.001, 0.01, 0.1\}$ with a fixed alpha $\alpha=0.0005$. \\
Figures \ref{fig:output_alpha_0.0005} to \ref{fig:output_alpha_0.5} show the resulting outputs for varying the alpha parameter $\alpha \in \{0.0005, 0.005, 0.05, 0.5\} $ with a fixed gamma $\gamma=0.0001$.
\begin{figure}[h]
	\centering
	\includegraphics[width=0.8\linewidth]{../input.jpg}
	\caption{Given input image}
	\label{fig:input}
\end{figure}%
\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\linewidth]{../output.jpg}
	\caption{Output for the following parameters:\\ 
			         $\sigma_1 = 0.7$, $\sigma_2=1.5$, $\alpha=0.0005$, $\gamma=0.0001$, $\tau=5$, end time = 100}
	\label{fig:output}
\end{figure}%
\begin{figure}[H]
\centering
\includegraphics[width=0.7\linewidth]{../input_handy.jpg}
\caption{Used input image for parameter tests}
\label{fig:input_handy}
\end{figure}%
\begin{figure}[H]
	\centering
	\begin{subfigure}{0.5\linewidth}
		\centering
		\includegraphics[width=0.99\linewidth]{{../output_alpha_0.0005_gamma_0.0001}.jpg}
		\caption{$\gamma = 0.0001$}
		\label{fig:output_gamma_0.0001}
	\end{subfigure}%
	\begin{subfigure}{0.5\linewidth}
		\centering
		\includegraphics[width=0.99\linewidth]{{../output_alpha_0.0005_gamma_0.001}.jpg}
		\caption{$\gamma = 0.001$}
		\label{fig:output_gamma_0.001}
	\end{subfigure}
	\begin{subfigure}{0.5\linewidth}
		\centering
		\includegraphics[width=0.99\linewidth]{{../output_alpha_0.0005_gamma_0.01}.jpg}
		\caption{$\gamma = 0.01$}
		\label{fig:output_gamma_0.01}
	\end{subfigure}%
	\begin{subfigure}{0.5\linewidth}
		\centering
		\includegraphics[width=0.99\linewidth]{{../output_alpha_0.0005_gamma_0.1}.jpg}
		\caption{$\gamma = 0.1$}
		\label{fig:output_gamma_0.1}
	\end{subfigure}
	\caption{Output for varying $\gamma$ with $\alpha=0.0005$}
	\label{fig:output_varying_gamma}
\end{figure}%
\begin{figure}[H]
	\centering
	\begin{subfigure}{0.5\linewidth}
		\centering
		\includegraphics[width=0.99\linewidth]{{../output_alpha_0.0005_gamma_0.0001}.jpg}
		\caption{$\alpha = 0.0005$}
		\label{fig:output_alpha_0.0005}
	\end{subfigure}%
	\begin{subfigure}{0.5\linewidth}
		\centering
		\includegraphics[width=0.99\linewidth]{{../output_alpha_0.005_gamma_0.0001}.jpg}
		\caption{$\alpha = 0.005$}
		\label{fig:output_alpha_0.005}
	\end{subfigure}
	\begin{subfigure}{0.5\linewidth}
		\centering
		\includegraphics[width=0.99\linewidth]{{../output_alpha_0.05_gamma_0.0001}.jpg}
		\caption{$\alpha = 0.05$}
		\label{fig:output_alpha_0.05}
	\end{subfigure}%
	\begin{subfigure}{0.5\linewidth}
		\centering
		\includegraphics[width=0.99\linewidth]{{../output_alpha_0.5_gamma_0.0001}.jpg}
		\caption{$\alpha = 0.5$}
		\label{fig:output_alpha_0.5}
	\end{subfigure}
	\caption{Output for varying $\alpha$ with $\gamma=0.0001$}
	\label{fig:output_varying_alpha}
\end{figure}%

\section*{Discussion}
As one can see in the output (Figure \ref{fig:output_varying_gamma}) a high $\gamma$ leads to an output image that is more similar to the input image. The lower the $\gamma$ value, the greater the intensity of the applied effect, leading to longer and wider "brush strokes".\\
\\
Increasing the value for $\alpha$ corresponds with a blurrier  output image. It almost looks like a Gaussian filter was applied.
\section*{Influence of $\alpha$ and $\gamma$}
The influence of $\alpha$ and $\gamma$ can be explained with the computation of the diffusion tensor 
\begin{equation} 
D = [v_1\ v_2]
\Big[\begin{array}{rr} 
	\lambda_1 & 0 \\ 
	0 & \lambda_2 
\end{array} \Big]
\Big[\begin{array}{r} 
	v_1^T \\
	v_2^T 
\end{array} \Big]
\end{equation}
with
\begin{equation}
\lambda_1 = \alpha
\end{equation}
\begin{equation}
\lambda_2 = \alpha + (1-\alpha)(1-g(|\mu_1-\mu_2|))
\end{equation}
\begin{equation}
	g(x)=\exp\Big(-\frac{x^2}{2\gamma^2}\Big)
\end{equation}
\\
The influence of $\alpha$ can be directly seen in equation (1) in combination with (2) and (3), as it denotes the radius of the diffusion area, if the diffusion area is seen as an ellipse which axes are given by the eigenvectors. With a greater diffusion radius yielding a larger diffusion area in all directions, the result will be a stronger blurred image, which is visible in Figure \ref{fig:output_varying_alpha}.\\
\\
$\gamma$ on the other hand is only influencing the value $\lambda_2$. In equation (1) we can 
see that $\lambda_2$ is influencing, or scaling, the second eigenvector, which is the eigenvector that denotes the direction of the edge (in opposition to the first eigenvector, which is directed orthogonality to the edge). Because we want to diffuse in direction of the edge, this makes sense.\\
Now, in equation (3) and (4), we see that $\gamma$ scales the influence of the difference of the eigenvalues. If one thinks through the 2 equations, the influence of $\gamma$ becomes a scaler for the difference of the eigenvectors, where a higher $\gamma$ leads to the need of a higher difference to achieve the same result.\\
As the difference of the eigenvectors can be interpreted as the "strongness" of an edge, the influence of $\gamma$ can be finally described as a threshold for a edge intensity that leads to the application of the brushing effect, which is also coherent with the results in Figure \ref{fig:output_varying_gamma}.
\section*{\texttt{spnabla\_hp}}
The \texttt{spnabla\_hp} function implements a kernel that is used to generate the gradient of an image in two directions. This computation can be also achieved by using a filter kernel
commonly known as Sobel or Sobel-Feldman filter.

\end{document}